;https://board.flatassembler.net/topic.php?t=13462
format PE GUI 4.0
include 'win32ax.inc'

.data

struct RGBQUAD
        rgbBlue db ?
        rgbGreen db ?
        rgbRed db ?
        rgbReserved db ?
ends

struct BITMAPINFO
        bmiHeader BITMAPINFOHEADER 40,800,600,1,24,0
        bmiColors RGBQUAD ?
ends

bmpHeader:              ; 54 bytes
        Signature       db 0x42,0x4D,0xC6,0x5F,0x01,00,00,00,00,00,0x36,00,00,00        ; 14 bytes
        bi24BitInfo     BITMAPINFO                                                      ; 40 bytes
pbits   dd ?

memDC   dd ?
winDC   dd ?
hDIB    dd ?
hFile   dd ?
bWritten dd ?

.code

start:
        ; Initialize bitmapinfo
;       mov [bi24BitInfo.bmiHeader.biSize], 40
;       mov [bi24BitInfo.bmiHeader.biWidth], 800
;       mov [bi24BitInfo.bmiHeader.biHeight], 600
;       mov [bi24BitInfo.bmiHeader.biPlanes], 1
;       mov [bi24BitInfo.bmiHeader.biBitCount],24
;       mov [bi24BitInfo.bmiHeader.biCompression], 0

        invoke CreateCompatibleDC, 0
        mov [memDC], eax
        invoke CreateDIBSection, eax, bi24BitInfo, 0, pbits, 0, 0
        mov [hDIB], eax
        invoke SelectObject, [memDC], eax

        invoke GetDC, 0
        mov [winDC],eax
        invoke StretchBlt, [memDC], 0, 0, 800, 600, eax, 0, 0, 1152, 864, 0xCC0020

        invoke CreateFile, 'cap.bmp', GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0
        mov [hFile], eax
        invoke WriteFile, eax, bmpHeader, 54, bWritten, 0
        invoke WriteFile, [hFile], [pbits], 1440000, bWritten, 0        ; 1440000 = 800 * 600 * 3
        invoke CloseHandle, [hFile]

        invoke DeleteDC, [memDC]
        invoke DeleteObject, [hDIB]
        invoke ReleaseDC,HWND_DESKTOP,[winDC]
        invoke ExitProcess, 0

.end start 